      REAL RM(15),X(2),XE(2),G(2),F,FE,TMAX
      REAL A(2),B(2),GE(2),UP(4)
      EXTERNAL GRAD,FUNC
      INTEGER N,IERR,IRM(2),I0(2)
      DATA X/-1.2,1.0/,XE/2*1.E-18/,FE/1.E-18/
      DATA A/-1.3,0.5/,B/0.5,1./
      DATA I0/2*1/,RM(1)/100./,GE/2*1.E-10/
      DATA UP/1.E-15,10.,1.2,100./,
     *     TMAX/30./,N/2/
      CALL UTMN05(T0)
      PRINT 10,X,A,B,XE,FE,GE,UP
      CALL MNR6R(X,XE,I0,A,B,N,FUNC,F,FE,GRAD,G,GE,UP,
     *RM,IRM,TMAX,IERR)
      CALL UTMN05(T1)
      DT= T1-T0
      PRINT 1,RM(1),RM(2),RM(3),IERR,F,X,G,DT
    1 FORMAT(2X,'K,NF,NG',3F5.0,' IERR = ',I6,/2X,'F,X,G',
     *      5E11.3,/2X,' DT = ',F6.2)
   10 FORMAT(2X,'. ',2E11.3,/' A = ',2E11.3,/,
     *      ' B = ',2E11.3,/' XE = ',2E12.3,/
     *      ' FE = ',E11.3,' GE = ',2E11.3,/' EPS = ',
     *      E11.3,' KR =  ',F5.0,' AKR = ',E11.3,' CDX = ',F5.0)
      STOP
      END
      SUBROUTINE FUNC(X,F,FE)
      REAL F,FE,X
      DIMENSION X(2)
      F=(X(2)-X(1)**2)**2+(1.-X(1))**2
      RETURN
      END
      SUBROUTINE GRAD(X,G,GE,I0)
      INTEGER I0      
      REAL G,GE,X
      DIMENSION G(2),GE(2),I0(2),X(2)
      G(1)=0.
      IF(I0(1).EQ.0) GO TO 10
      G(1)=-4.*(X(2)-X(1)**2)*X(1)-2.*(1.-X(1))
   10 CONTINUE
      G(2)=0.
      IF(I0(2).EQ.0) GO TO 20
      G(2)=2.*(X(2)-X(1)**2)
   20 CONTINUE
      RETURN
      END 

